=== debian/changelog ===
ros-indigo-rtt-roscomm (2.8.6-0trusty) trusty; urgency=high

  * rtt_roscomm: also set ${PROJECT_NAME}_EXPORTED_LIBRARIES in parent scope
    Related to https://github.com/orocos-toolchain/rtt/pull/244.
  * Contributors: Johannes Meyer

 -- Orocos Developers <orocos-dev@lists.mech.kuleuven.be>  Tue, 14 Nov 2017 23:00:00 -0000

ros-indigo-rtt-roscomm (2.8.5-0trusty) trusty; urgency=high

  * Merge pull request #85 <https://github.com/orocos/rtt_ros_integration/issues/85> from meyerj/ros-primitives-transport-indigo-devel
    Added a ROS transport plugin for primitive types (indigo-devel)
  * rtt_roscomm: fix caller engine in RosServiceServerProxyBase to make sure that OwnThread operations are executed in the owner's thread
  * rtt_roscomm: added topicLatched() method to rtt_rostopic service
  * rtt_roscomm: only set CMAKE_BUILD_TYPE to MinSizeRel if either not set or if it was Release before
    This enables debugging of ROS typekits.
  * Contributors: Johannes Meyer

 -- Orocos Developers <orocos-dev@lists.mech.kuleuven.be>  Mon, 27 Mar 2017 22:00:00 -0000

ros-indigo-rtt-roscomm (2.8.4-0trusty) trusty; urgency=high

  * Merge pull request #79 <https://github.com/orocos/rtt_ros_integration/issues/79> from meyerj/added-rtt-rosservice-operations
    rtt_roscomm: added operations disconnect() and disconnectAll() to the rosservice service
  * Merge branch 'B`#59 <https://github.com/orocos/rtt_ros_integration/issues/59>`__cleaning_registered_services' of https://github.com/ubi-agni/rtt_ros_integration into indigo-devel
  * rtt_roscomm: include exported headers and link typekit and transport plugin to exported libraries
  * rtt_roscomm: export build dependency roscpp
  * Contributors: Johannes Meyer, Guillaume Walck

 -- Orocos Developers <orocos-dev@lists.mech.kuleuven.be>  Fri, 25 Nov 2016 23:00:00 -0000

ros-indigo-rtt-roscomm (2.8.3-0trusty) trusty; urgency=high

  * rtt_roscomm: set minimum ROS subscriber queue_size to 1
  * rtt_roscomm: fixed destruction of RosSubChannelElement<T> and ROS subscriber shutdown (fix #61 <https://github.com/orocos/rtt_ros_integration/issues/61>)
  * Contributors: Johannes Meyer

 -- Orocos Developers <orocos-dev@lists.mech.kuleuven.be>  Tue, 19 Jul 2016 22:00:00 -0000

ros-indigo-rtt-roscomm (2.8.2-0trusty) trusty; urgency=high

  * see rtt_ros_integratoin/CHANGELOG.rst <../rtt_ros_integration/CHANGELOG.rst>

 -- Orocos Developers <orocos-dev@lists.mech.kuleuven.be>  Thu, 11 Jun 2015 22:00:00 -0000
